[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[Condor-users] patch: preliminary debian support



hi,

i didn't find where to post this: if this ML isn't the right place, please tell me !

the enclosed patch adds debian and ubuntu support for condor. it just fixes compile problems for now.

preliminary notes :
- debian/stable (sarge) uses gcc-3.3.5 : i've just added its declaration in src/configure.ac
- debian/testing, from which ubuntu/dapper is a snapshot, uses gcc-4.0.3
- gcc-4.0.3 is the most touchy c++ compiler ever, as far as c++-compliance is concerned. thus, some fixes...




-----------------------
add gcc-4.0.3 and gcc-3.3.5 support and a LINUX_DEBIAN opsys_ver (see full patch in attached diff):

=== modified file 'src/configure.ac'
--- src/configure.ac    2006-10-17 15:28:36 +0000
+++ src/configure.ac    2006-10-19 07:52:56 +0000
@@ -256,9 +256,8 @@
     esac
   elif test -f "/etc/debian_version" ; then
     _deb_vers=`cat /etc/debian_version | sed 's/\./_/g'`;
-    _cv_linux_distro="DEBIAN_`echo _deb_vers`"
-    AC_MSG_WARN([Condor is not yet ported to Debian Linux distributions])
-    AC_MSG_WARN([You may have trouble building and/or packaging Condor])
+    _cv_opsys_vers="LINUX_DEBIAN"
+    _cv_linux_distro="DEBIAN"
<SNIP>

-----------------------
classads should support g++-4.0 :

=== added file 'externals/bundles/classads/0.9.8-b3/g++4.0.patch'
--- externals/bundles/classads/0.9.8-b3/g++4.0.patch    1970-01-01 00:00:00 +0000
+++ externals/bundles/classads/0.9.8-b3/g++4.0.patch    2006-10-18 13:12:03 +0000
@@ -0,0 +1,11 @@
+--- classads-0.9.8-b3/classad_stl.h    2005-10-27 21:10:49.000000000 +0200
++++ classads-0.9.8-b3/classad_stl.h.patched    2006-10-18 15:11:26.000000000 +0200
+@@ -42,7 +42,7 @@
+
+
+ #ifdef __GNUC__
+-  #if (__GNUC__ == 3 && __GNUC_MINOR__ > 0)
++  #if (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ > 0))
+     #define classad_hash_map __gnu_cxx::hash_map
+     #define classad_slist    __gnu_cxx::slist
+   #else

=== modified file 'externals/bundles/classads/0.9.8-b3/build_classads-0.9.8-b3'
--- externals/bundles/classads/0.9.8-b3/build_classads-0.9.8-b3 2006-10-17 15:28:36 +0000
+++ externals/bundles/classads/0.9.8-b3/build_classads-0.9.8-b3 2006-10-18 13:07:46 +0000
@@ -4,6 +4,8 @@
 # It is unlikely that anyone will want to use it.
 # This script is renamed to something like build_classads-0.9.7

+patch -i g++4.0.patch -p0
+
 cd $PACKAGE_BUILD_DIR/$PACKAGE_NAME/

 ##### Configure and Build ClassAds #####






-----------------------
i didn't managed yet to get blahp compiled and i want to use system's glibc :

=== added file 'config/LINUX_DEBIAN.cf'
--- config/LINUX_DEBIAN.cf      1970-01-01 00:00:00 +0000
+++ config/LINUX_DEBIAN.cf      2006-10-18 21:15:34 +0000
@@ -0,0 +1,8 @@
+/* Things specific to LINUX_DEBIAN machines */
+
+#ifdef WANT_BLAHP
+#  undef WANT_BLAHP
+#endif
+#define WANT_BLAHP     NO
+
+GLIBC_DIR = /usr/lib

=== modified file 'config/LINUX.cf'
--- config/LINUX.cf     2006-10-17 15:28:36 +0000
+++ config/LINUX.cf     2006-10-18 22:23:11 +0000
@@ -115,3 +115,7 @@
 #include ArchIncludeFile
 #endif

+#ifdef OSVersionIncludeFile
+#include OSVersionIncludeFile
+#endif
+

=== modified file 'config/Platform.select'
--- config/Platform.select      2006-10-17 15:28:36 +0000
+++ config/Platform.select      2006-10-18 16:09:12 +0000
@@ -50,6 +50,9 @@

 #elif defined( IS_LINUX )
 #  define PlatformIncludeFile <LINUX.cf>
+#  if defined( IS_LINUX_DEBIAN )
+#    define OSVersionIncludeFile <LINUX_DEBIAN.cf>
+#  endif
 #  if defined( IS_I386 )
 #    define ArchIncludeFile <LINUX_I386.cf>
 #  elif defined( IS_ALPHA )







-----------------------
-mcpu is deprecated in gcc-4.0 :

=== modified file 'config/LINUX_I386.cf'
--- config/LINUX_I386.cf        2006-10-17 15:28:36 +0000
+++ config/LINUX_I386.cf        2006-10-18 16:35:22 +0000
@@ -1,9 +1,13 @@
 /* Things specific to I386_LINUX machines (all versions) */

-#ifdef IS_C_COMP_MAJOR_GCC_3
-#define ArchOptimizeFlag -mcpu=i486
+#ifdef IS_C_COMP_MAJOR_GCC_4
+# define ArchOptimizeFlag -march=i486
 #else
-#define ArchOptimizeFlag -m486
+# ifdef IS_C_COMP_MAJOR_GCC_3
+#  define ArchOptimizeFlag -mcpu=i486
+# else
+#  define ArchOptimizeFlag -m486
+# endif
 #endif

 #ifdef IS_GLIBC23



-----------------------
general gcc-4.0 support :

=== modified file 'config/configure.cf.in'
--- config/configure.cf.in      2006-10-17 15:28:36 +0000
+++ config/configure.cf.in      2006-10-18 16:24:42 +0000
@@ -42,7 +42,7 @@
 CCOMPILER_ID = $(C_COMP_KIND) $(C_COMP_MAJOR) $(C_COMP_MINOR) $(C_COMP_PATCH)
 /* compiler related libraries and .o files we need */
 LIB_STDCPP = @lib_std_cpp@
-#if IS_C_COMP_KIND_GCC && IS_C_COMP_MAJOR_GCC_3
+#if IS_C_COMP_KIND_GCC && ( IS_C_COMP_MAJOR_GCC_3 || IS_C_COMP_MAJOR_GCC_4 )
 LIB_GCC_EH = @lib_gcc_eh@
 #endif
 GCC_LIBC = @gcc_libc@

=== modified file 'src/condor_ckpt/Imakefile'
--- src/condor_ckpt/Imakefile   2006-10-17 15:28:36 +0000
+++ src/condor_ckpt/Imakefile   2006-10-18 16:11:13 +0000
@@ -126,7 +126,7 @@
 /* Figure out what should be in the libc++support library, if anything */
 #if DOES_CHECKPOINTING

-#if IS_C_COMP_MAJOR_GCC_3
+#if IS_C_COMP_MAJOR_GCC_3 || IS_C_COMP_MAJOR_GCC_4
 # define NEEDS_CPP_SUPPORT_LIB 0
   CPP_SUPPORT_LIB =
 #else /* non gcc 3.x */







-----------------------
clean namespace for gcc-4.0's sake (see full patch in attached diff):

=== modified file 'src/condor_credd/classadUtil.C'
--- src/condor_credd/classadUtil.C      2006-10-17 15:28:36 +0000
+++ src/condor_credd/classadUtil.C      2006-10-18 23:00:09 +0000
@@ -28,13 +28,13 @@
 BEGIN_NAMESPACE( classad )


-bool getOldClassAd( Stream *sock, classad::ClassAd& ad )
+bool getOldClassAd( Stream *sock, ClassAd& ad )
 {
<SNIP>

-bool classad::putOldClassAd ( Stream *sock, classad::ClassAd& ad )
+bool putOldClassAd ( Stream *sock, ClassAd& ad )
<SNIP>

=== modified file 'src/condor_credd/classadUtil.h'
--- src/condor_credd/classadUtil.h      2006-10-17 15:28:36 +0000
+++ src/condor_credd/classadUtil.h      2006-10-18 22:48:24 +0000
@@ -35,8 +35,8 @@

 BEGIN_NAMESPACE( classad )

-bool getOldClassAd( Stream *sock, classad::ClassAd& ad );
-bool putOldClassAd ( Stream *sock, classad::ClassAd& ad );
+bool getOldClassAd( Stream *sock, ClassAd& ad );
+bool putOldClassAd ( Stream *sock, ClassAd& ad );
<SNIP>







-----------------------
this one is suspect: i had to pass parameter by reference to comply with prototype's declaration.
without this, gcc-4.0 bails out with an error

=== modified file 'src/condor_credd/get_cred.C'
--- src/condor_credd/get_cred.C 2006-10-17 15:28:36 +0000
+++ src/condor_credd/get_cred.C 2006-10-18 23:01:15 +0000
@@ -36,7 +36,7 @@
   int cred_size = 0;

   DCCredd credd(credd_sin);
-  if (credd.getCredentialData (cred_name, (void*)cred_data, cred_size, errorstack)) {
+  if (credd.getCredentialData ((const char*)cred_name, (void*&)cred_data, cred_size, errorstack)) {
       printf ("Received %d \n%s\n", cred_size, cred_data);
          return 0;
   } else {




-----------------------
quite the same as above : code maintainer should check this is the expected behaviour:

=== modified file 'src/stork/dap_client_interface.C'
--- src/stork/dap_client_interface.C    2006-10-17 15:28:36 +0000
+++ src/stork/dap_client_interface.C    2006-10-18 23:02:29 +0000
@@ -242,7 +242,7 @@
        }
        free (_request);

-       sock->code ((int)cred_size);
+       sock->code ((int*)&cred_size);
        if (cred_size) {
                char * _cred = strdup (cred);
                sock->code_bytes (_cred, cred_size);




-----------------------
proper utimes() support :

=== modified file 'src/condor_syscall_lib/Imakefile'
--- src/condor_syscall_lib/Imakefile    2006-10-17 15:28:36 +0000
+++ src/condor_syscall_lib/Imakefile    2006-10-18 22:26:52 +0000
@@ -588,7 +588,7 @@
 #endif


-#if ! IS_CLIPPED && IS_GLIBC
+#if ! IS_CLIPPED && IS_GLIBC && ! IS_LINUX_DEBIAN
 /*
    glibc 2.1.3 added/renamed some libc calls that broke how we trap
    stuff.  So in order to not have a release tar ball for EACH redhat
@@ -617,7 +617,7 @@
 #endif /* ! IS_CLIPPED && IS_GLIBC */


-#if ! IS_CLIPPED && IS_C_COMP_MAJOR_GCC_3
+#if ! IS_CLIPPED && (IS_C_COMP_MAJOR_GCC_3 || IS_C_COMP_MAJOR_GCC_4)
 /*
    Starting with gcc3, we are going to ship three internal libraries
    that come with the compiler that we are going to use to replace

=== modified file 'src/condor_syscall_lib/syscall.tmpl'
--- src/condor_syscall_lib/syscall.tmpl 2006-10-17 15:28:36 +0000
+++ src/condor_syscall_lib/syscall.tmpl 2006-10-18 20:28:14 +0000
@@ -872,7 +872,7 @@
        }


-#      if defined( LINUX ) && !( defined( LINUX_CENTOS42 ) || defined( LINUX_CENTOS43 ) || defined( LINUX_CENTOS44 ) )
+#      if defined( LINUX ) && !( defined( LINUX_CENTOS42 ) || defined( LINUX_CENTOS43 ) || defined( LINUX_CENTOS44 ) || def\
ined(LINUX_DEBIAN) )
        /* CENTOS42 uses a header files where this func is const, but
                the glibc that we use with condor does not define this
                function as const. So this avoids link errors. */




-----------------------
gcc-4.0 won't compile stub_gen parsor if it hasn't append_node()'s prototype:

=== modified file 'src/condor_util_lib/stub_gen_yacc.y'
--- src/condor_util_lib/stub_gen_yacc.y 2006-10-17 15:28:36 +0000
+++ src/condor_util_lib/stub_gen_yacc.y 2006-10-18 19:44:48 +0000
@@ -55,6 +55,7 @@
        int is_in, int is_out, int is_vararg );
 struct node * mk_action_param_node( char *name, int is_ref, char *mult );
 struct node *insert_node( struct node *list, struct node *new_elem );
+struct node *append_node( struct node *list, struct node *new_elem );
 void display_node( struct node * );
 void output_switch( struct node * );
 void display_list( struct node * );




-----------------------
pvm does'nt compile with gcc-4.0 as struct Pvmtevdid pvmtevdidlist[] is ill-defined...
(see full patch in attached diff)

=== added file 'externals/bundles/pvm/3.4.2/gcc-4.0.patch'
--- externals/bundles/pvm/3.4.2/gcc-4.0.patch   1970-01-01 00:00:00 +0000
+++ externals/bundles/pvm/3.4.2/gcc-4.0.patch   2006-10-18 13:54:09 +0000
<SNIP>




-----------------------
SRB has a prototype declaration problem. moreover, it is non-free, so i'm not interested yet in supporting it:


=== modified file 'src/stork/Imakefile'
--- src/stork/Imakefile 2006-10-17 15:28:36 +0000
+++ src/stork/Imakefile 2006-10-19 07:32:37 +0000
@@ -6,7 +6,7 @@
 /* Specify Stork build configuration here. */
 #define WANT_STORK_API                 YES
 #define WANT_STORK_GLOBUS              YES
-#define WANT_STORK_SRB                 YES
+#define WANT_STORK_SRB                 NO
 #define WANT_STORK_UNITREE             YES
 #define WANT_STORK_SRM_CASTOR  YES
 #define WANT_STORK_SRM_DCACHE  YES


-----------------------
linux/swap.h has trouble as it try to find a non-existant (in debian) linux/mmzone.h.
i'm not proud of this one... we must find something better than !defined(LINUX) :


=== modified file 'src/condor_includes/condor_sys_linux.h'
--- src/condor_includes/condor_sys_linux.h      2006-10-17 15:28:36 +0000
+++ src/condor_includes/condor_sys_linux.h      2006-10-18 20:32:35 +0000
@@ -132,7 +132,7 @@
 #endif

 /* swapon and swapoff prototypes */
-#if !defined(IA64) && !defined(CONDOR_PPC)
+#if !defined(IA64) && !defined(CONDOR_PPC) && !defined(LINUX)
 /* there is a bug in this header file for ia64 linux, figure out what I need
        out of here and prototype it manually. */
 #include <linux/swap.h>

-----------------------






with that, i successfully compiled condor under both debian/sarge
and ubuntu/dapper.

i will happily discuss these patches with source code maintainers,
as i'm tackling with having condor go in debian's main archive.

is there a better place to discuss these points ?


regards,
-- 
guillaume pernot
http://www.praksys.org - Midi-Pyrénées et Aquitaine
Membre du réseau Libre Entreprise
GPG fingerprint : D356 5318 CE52 64C9 0CEF
=== added file 'config/LINUX_DEBIAN.cf'
--- config/LINUX_DEBIAN.cf	1970-01-01 00:00:00 +0000
+++ config/LINUX_DEBIAN.cf	2006-10-18 21:15:34 +0000
@@ -0,0 +1,8 @@
+/* Things specific to LINUX_DEBIAN machines */
+
+#ifdef WANT_BLAHP
+#  undef WANT_BLAHP
+#endif
+#define WANT_BLAHP	NO
+
+GLIBC_DIR = /usr/lib

=== added file 'externals/bundles/classads/0.9.8-b3/g++4.0.patch'
--- externals/bundles/classads/0.9.8-b3/g++4.0.patch	1970-01-01 00:00:00 +0000
+++ externals/bundles/classads/0.9.8-b3/g++4.0.patch	2006-10-18 13:12:03 +0000
@@ -0,0 +1,11 @@
+--- classads-0.9.8-b3/classad_stl.h	2005-10-27 21:10:49.000000000 +0200
++++ classads-0.9.8-b3/classad_stl.h.patched	2006-10-18 15:11:26.000000000 +0200
+@@ -42,7 +42,7 @@
+ 	
+ 
+ #ifdef __GNUC__
+-  #if (__GNUC__ == 3 && __GNUC_MINOR__ > 0)
++  #if (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ > 0))
+     #define classad_hash_map __gnu_cxx::hash_map 
+     #define classad_slist    __gnu_cxx::slist
+   #else

=== added file 'externals/bundles/pvm/3.4.2/gcc-4.0.patch'
--- externals/bundles/pvm/3.4.2/gcc-4.0.patch	1970-01-01 00:00:00 +0000
+++ externals/bundles/pvm/3.4.2/gcc-4.0.patch	2006-10-18 13:54:09 +0000
@@ -0,0 +1,63 @@
+diff -ruN pvm-3.4.2/include/pvm_global.h pvm-3.4.2.patched/include/pvm_global.h
+--- pvm-3.4.2/include/pvm_global.h	2003-09-24 18:40:35.000000000 +0200
++++ pvm-3.4.2.patched/include/pvm_global.h	2006-10-18 15:50:25.000000000 +0200
+@@ -306,10 +306,4 @@
+ extern	struct pvmmclass *pvmmboxclasses;		/* the mbox database */
+ 
+ 
+-/* General Trace Globals Declarations */
+-
+-extern	struct Pvmtevdid pvmtevdidlist[];
+-
+-extern	struct Pvmtevinfo pvmtevinfo[];
+-
+ #define OVERLOADHOST
+diff -ruN pvm-3.4.2/src/global.h pvm-3.4.2.patched/src/global.h
+--- pvm-3.4.2/src/global.h	2003-09-24 18:40:35.000000000 +0200
++++ pvm-3.4.2.patched/src/global.h	2006-10-18 15:50:25.000000000 +0200
+@@ -306,10 +306,4 @@
+ extern	struct pvmmclass *pvmmboxclasses;		/* the mbox database */
+ 
+ 
+-/* General Trace Globals Declarations */
+-
+-extern	struct Pvmtevdid pvmtevdidlist[];
+-
+-extern	struct Pvmtevinfo pvmtevinfo[];
+-
+ #define OVERLOADHOST
+diff -ruN pvm-3.4.2/src/pmsg.c pvm-3.4.2.patched/src/pmsg.c
+--- pvm-3.4.2/src/pmsg.c	1999-07-08 21:00:05.000000000 +0200
++++ pvm-3.4.2.patched/src/pmsg.c	2006-10-18 15:51:20.000000000 +0200
+@@ -151,6 +151,7 @@
+  **           **
+  ***************/
+ 
++extern struct Pvmtevinfo pvmtevinfo[];
+ 
+ /***************
+  **  Private  **
+diff -ruN pvm-3.4.2/src/pvmdtev.c pvm-3.4.2.patched/src/pvmdtev.c
+--- pvm-3.4.2/src/pvmdtev.c	1998-11-20 21:06:41.000000000 +0100
++++ pvm-3.4.2.patched/src/pvmdtev.c	2006-10-18 15:51:54.000000000 +0200
+@@ -73,6 +73,8 @@
+ static int init_start = 0;
+ static int init_end = 0;
+ 
++extern struct Pvmtevdid pvmtevdidlist[];
++extern struct Pvmtevinfo pvmtevinfo[];
+ 
+ void
+ tev_init_pvmd( dst, ctx, tag )
+diff -ruN pvm-3.4.2/src/tev.c pvm-3.4.2.patched/src/tev.c
+--- pvm-3.4.2/src/tev.c	1998-11-20 21:04:18.000000000 +0100
++++ pvm-3.4.2.patched/src/tev.c	2006-10-18 15:52:18.000000000 +0200
+@@ -72,7 +72,7 @@
+  ***************/
+ 
+ struct pmsg *midtobuf();
+-
++extern struct Pvmtevinfo pvmtevinfo[];
+ 
+ /***************
+  **  Private  **

=== modified file 'config/LINUX.cf'
--- config/LINUX.cf	2006-10-17 15:28:36 +0000
+++ config/LINUX.cf	2006-10-18 22:23:11 +0000
@@ -115,3 +115,7 @@
 #include ArchIncludeFile
 #endif
 
+#ifdef OSVersionIncludeFile
+#include OSVersionIncludeFile
+#endif
+

=== modified file 'config/LINUX_I386.cf'
--- config/LINUX_I386.cf	2006-10-17 15:28:36 +0000
+++ config/LINUX_I386.cf	2006-10-18 16:35:22 +0000
@@ -1,9 +1,13 @@
 /* Things specific to I386_LINUX machines (all versions) */
 
-#ifdef IS_C_COMP_MAJOR_GCC_3
-#define ArchOptimizeFlag -mcpu=i486
+#ifdef IS_C_COMP_MAJOR_GCC_4
+# define ArchOptimizeFlag -march=i486
 #else
-#define ArchOptimizeFlag -m486
+# ifdef IS_C_COMP_MAJOR_GCC_3
+#  define ArchOptimizeFlag -mcpu=i486
+# else
+#  define ArchOptimizeFlag -m486
+# endif
 #endif
 
 #ifdef IS_GLIBC23

=== modified file 'config/Platform.select'
--- config/Platform.select	2006-10-17 15:28:36 +0000
+++ config/Platform.select	2006-10-18 16:09:12 +0000
@@ -50,6 +50,9 @@
 
 #elif defined( IS_LINUX )
 #  define PlatformIncludeFile <LINUX.cf>
+#  if defined( IS_LINUX_DEBIAN )
+#    define OSVersionIncludeFile <LINUX_DEBIAN.cf>
+#  endif
 #  if defined( IS_I386 ) 
 #    define ArchIncludeFile <LINUX_I386.cf>
 #  elif defined( IS_ALPHA )

=== modified file 'config/configure.cf.in'
--- config/configure.cf.in	2006-10-17 15:28:36 +0000
+++ config/configure.cf.in	2006-10-18 16:24:42 +0000
@@ -42,7 +42,7 @@
 CCOMPILER_ID = $(C_COMP_KIND) $(C_COMP_MAJOR) $(C_COMP_MINOR) $(C_COMP_PATCH)
 /* compiler related libraries and .o files we need */
 LIB_STDCPP = @lib_std_cpp@
-#if IS_C_COMP_KIND_GCC && IS_C_COMP_MAJOR_GCC_3
+#if IS_C_COMP_KIND_GCC && ( IS_C_COMP_MAJOR_GCC_3 || IS_C_COMP_MAJOR_GCC_4 )
 LIB_GCC_EH = @lib_gcc_eh@
 #endif
 GCC_LIBC = @gcc_libc@

=== modified file 'externals/bundles/classads/0.9.8-b3/build_classads-0.9.8-b3'
--- externals/bundles/classads/0.9.8-b3/build_classads-0.9.8-b3	2006-10-17 15:28:36 +0000
+++ externals/bundles/classads/0.9.8-b3/build_classads-0.9.8-b3	2006-10-18 13:07:46 +0000
@@ -4,6 +4,8 @@
 # It is unlikely that anyone will want to use it. 
 # This script is renamed to something like build_classads-0.9.7
 
+patch -i g++4.0.patch -p0
+
 cd $PACKAGE_BUILD_DIR/$PACKAGE_NAME/
 
 ##### Configure and Build ClassAds #####

=== modified file 'src/condor_ckpt/Imakefile'
--- src/condor_ckpt/Imakefile	2006-10-17 15:28:36 +0000
+++ src/condor_ckpt/Imakefile	2006-10-18 16:11:13 +0000
@@ -126,7 +126,7 @@
 /* Figure out what should be in the libc++support library, if anything */
 #if DOES_CHECKPOINTING
 
-#if IS_C_COMP_MAJOR_GCC_3
+#if IS_C_COMP_MAJOR_GCC_3 || IS_C_COMP_MAJOR_GCC_4
 # define NEEDS_CPP_SUPPORT_LIB 0
   CPP_SUPPORT_LIB =
 #else /* non gcc 3.x */

=== modified file 'src/condor_credd/classadUtil.C'
--- src/condor_credd/classadUtil.C	2006-10-17 15:28:36 +0000
+++ src/condor_credd/classadUtil.C	2006-10-18 23:00:09 +0000
@@ -28,13 +28,13 @@
 BEGIN_NAMESPACE( classad )
 
 
-bool getOldClassAd( Stream *sock, classad::ClassAd& ad )
+bool getOldClassAd( Stream *sock, ClassAd& ad )
 {
-	classad::ClassAdParser	parser;
+	ClassAdParser	parser;
 	int 			numExprs;
 	string			buffer;
 	char			*tmp;
-	classad::ClassAd			*upd=NULL;
+	ClassAd			*upd=NULL;
 	static char		*inputLine = new char[ 10240 ];
 
 
@@ -73,7 +73,7 @@
 
 #if 0
 		// put exprs into ad
-	classad::ClassAd *tmpAd = new classad::ClassAd( );
+	ClassAd *tmpAd = new ClassAd( );
 	tmpAd->Update( *upd );
 	tmpAd = tmpAd->AddExplicitTargetRefs( );
 #endif
@@ -86,21 +86,21 @@
 	return true;
 }
 
-bool classad::putOldClassAd ( Stream *sock, classad::ClassAd& ad )
+bool putOldClassAd ( Stream *sock, ClassAd& ad )
 {
-	classad::ClassAdUnParser	unp;
+	ClassAdUnParser	unp;
 	string			buf;
-	classad::ExprTree		*expr;
+	ExprTree		*expr;
 
 	int numExprs=0;
-	classad::ClassAdIterator itor(ad);
+	ClassAdIterator itor;
 	while( !itor.IsAfterLast( ) ) {
-		itor.CurrentAttribute( buf, (const classad::ExprTree *)expr );
+		itor.CurrentAttribute( buf, (const ExprTree *&)expr );
 		if( strcasecmp( "MyType", buf.c_str( ) ) != 0 && 
 				strcasecmp( "TargetType", buf.c_str( ) ) != 0 ) {
 			numExprs++;
 		}
-		itor.NextAttribute( buf, (const classad::ExprTree *) expr );
+		itor.NextAttribute( buf, (const ExprTree *&) expr );
 	}
 	
 	sock->encode( );
@@ -109,8 +109,8 @@
 	}
 		
 	for( itor.ToFirst(); !itor.IsAfterLast(); itor.NextAttribute(buf, (const
-					classad::ExprTree *) expr) ) {
-		itor.CurrentAttribute( buf, (const classad::ExprTree *) expr );
+					ExprTree *&) expr) ) {
+		itor.CurrentAttribute( buf, (const ExprTree *&) expr );
 		if( strcasecmp( "MyType", buf.c_str( ) ) == 0 || 
 				strcasecmp( "TargetType", buf.c_str( ) ) == 0 ) {
 			continue;

=== modified file 'src/condor_credd/classadUtil.h'
--- src/condor_credd/classadUtil.h	2006-10-17 15:28:36 +0000
+++ src/condor_credd/classadUtil.h	2006-10-18 22:48:24 +0000
@@ -35,8 +35,8 @@
 
 BEGIN_NAMESPACE( classad )
 
-bool getOldClassAd( Stream *sock, classad::ClassAd& ad );
-bool putOldClassAd ( Stream *sock, classad::ClassAd& ad );
+bool getOldClassAd( Stream *sock, ClassAd& ad );
+bool putOldClassAd ( Stream *sock, ClassAd& ad );
 
 END_NAMESPACE // classad
 #endif // __CLASSADUTIL_H__

=== modified file 'src/condor_credd/get_cred.C'
--- src/condor_credd/get_cred.C	2006-10-17 15:28:36 +0000
+++ src/condor_credd/get_cred.C	2006-10-18 23:01:15 +0000
@@ -36,7 +36,7 @@
   int cred_size = 0;
 
   DCCredd credd(credd_sin);
-  if (credd.getCredentialData (cred_name, (void*)cred_data, cred_size, errorstack)) {
+  if (credd.getCredentialData ((const char*)cred_name, (void*&)cred_data, cred_size, errorstack)) {
       printf ("Received %d \n%s\n", cred_size, cred_data);
 	  return 0;
   } else {

=== modified file 'src/condor_includes/condor_sys_linux.h'
--- src/condor_includes/condor_sys_linux.h	2006-10-17 15:28:36 +0000
+++ src/condor_includes/condor_sys_linux.h	2006-10-18 20:32:35 +0000
@@ -132,7 +132,7 @@
 #endif
 
 /* swapon and swapoff prototypes */
-#if !defined(IA64) && !defined(CONDOR_PPC)
+#if !defined(IA64) && !defined(CONDOR_PPC) && !defined(LINUX)
 /* there is a bug in this header file for ia64 linux, figure out what I need
 	out of here and prototype it manually. */
 #include <linux/swap.h>

=== modified file 'src/condor_syscall_lib/Imakefile'
--- src/condor_syscall_lib/Imakefile	2006-10-17 15:28:36 +0000
+++ src/condor_syscall_lib/Imakefile	2006-10-18 22:26:52 +0000
@@ -588,7 +588,7 @@
 #endif
 
 
-#if ! IS_CLIPPED && IS_GLIBC
+#if ! IS_CLIPPED && IS_GLIBC && ! IS_LINUX_DEBIAN
 /*
    glibc 2.1.3 added/renamed some libc calls that broke how we trap
    stuff.  So in order to not have a release tar ball for EACH redhat
@@ -617,7 +617,7 @@
 #endif /* ! IS_CLIPPED && IS_GLIBC */
 
 
-#if ! IS_CLIPPED && IS_C_COMP_MAJOR_GCC_3
+#if ! IS_CLIPPED && (IS_C_COMP_MAJOR_GCC_3 || IS_C_COMP_MAJOR_GCC_4)
 /*
    Starting with gcc3, we are going to ship three internal libraries
    that come with the compiler that we are going to use to replace

=== modified file 'src/condor_syscall_lib/syscall.tmpl'
--- src/condor_syscall_lib/syscall.tmpl	2006-10-17 15:28:36 +0000
+++ src/condor_syscall_lib/syscall.tmpl	2006-10-18 20:28:14 +0000
@@ -872,7 +872,7 @@
 	}
 
 
-#	if defined( LINUX ) && !( defined( LINUX_CENTOS42 ) || defined( LINUX_CENTOS43 ) || defined( LINUX_CENTOS44 ) )
+#	if defined( LINUX ) && !( defined( LINUX_CENTOS42 ) || defined( LINUX_CENTOS43 ) || defined( LINUX_CENTOS44 ) || defined(LINUX_DEBIAN) )
 	/* CENTOS42 uses a header files where this func is const, but
 		the glibc that we use with condor does not define this
 		function as const. So this avoids link errors. */

=== modified file 'src/condor_util_lib/stub_gen_yacc.y'
--- src/condor_util_lib/stub_gen_yacc.y	2006-10-17 15:28:36 +0000
+++ src/condor_util_lib/stub_gen_yacc.y	2006-10-18 19:44:48 +0000
@@ -55,6 +55,7 @@
 	int is_in, int is_out, int is_vararg );
 struct node * mk_action_param_node( char *name, int is_ref, char *mult );
 struct node *insert_node( struct node *list, struct node *new_elem );
+struct node *append_node( struct node *list, struct node *new_elem );
 void display_node( struct node * );
 void output_switch( struct node * );
 void display_list( struct node * );

=== modified file 'src/configure'
--- src/configure	2006-10-17 15:28:36 +0000
+++ src/configure	2006-10-18 21:07:11 +0000
@@ -966,7 +966,7 @@
     else
       echo "$as_me: WARNING: no configuration information is in $ac_dir" >&2
     fi
-    cd $ac_popdir
+    cd "$ac_popdir"
   done
 fi
 
@@ -1792,11 +1792,8 @@
     esac
   elif test -f "/etc/debian_version" ; then
     _deb_vers=`cat /etc/debian_version | sed 's/\./_/g'`;
-    _cv_linux_distro="DEBIAN_`echo _deb_vers`"
-    { echo "$as_me:$LINENO: WARNING: Condor is not yet ported to Debian Linux distributions" >&5
-echo "$as_me: WARNING: Condor is not yet ported to Debian Linux distributions" >&2;}
-    { echo "$as_me:$LINENO: WARNING: You may have trouble building and/or packaging Condor" >&5
-echo "$as_me: WARNING: You may have trouble building and/or packaging Condor" >&2;}
+    _cv_opsys_vers="LINUX_DEBIAN"
+    _cv_linux_distro="DEBIAN"
   else
     { echo "$as_me:$LINENO: WARNING: Unrecognised Linux distribution" >&5
 echo "$as_me: WARNING: Unrecognised Linux distribution" >&2;}
@@ -3127,8 +3124,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_c_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_c_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -3186,8 +3182,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_c_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_c_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -3303,8 +3298,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_c_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_c_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -3358,8 +3352,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_c_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_c_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -3404,8 +3397,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_c_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_c_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -3449,8 +3441,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_c_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_c_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -3642,6 +3633,18 @@
     CompilerMinor="0"
     CompilerPatch="1"
     ;;
+ "4.0.2" )
+    CompilerKind="GCC"
+    CompilerMajor="4"
+    CompilerMinor="0"
+    CompilerPatch="2"
+    ;;
+ "4.0.3" )
+    CompilerKind="GCC"
+    CompilerMajor="4"
+    CompilerMinor="0"
+    CompilerPatch="3"
+    ;;
  * )
    echo "$as_me:$LINENO: result: ERROR" >&5
 echo "${ECHO_T}ERROR" >&6
@@ -3944,8 +3947,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -4003,8 +4005,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -4075,8 +4076,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -4120,8 +4120,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -5584,8 +5583,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -5651,8 +5649,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -5741,8 +5738,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -6707,8 +6703,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -7029,8 +7024,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -7200,8 +7194,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -7268,8 +7261,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -7418,8 +7410,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -7568,8 +7559,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -7718,8 +7708,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -7868,8 +7857,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -8018,8 +8006,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -8168,8 +8155,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -8318,8 +8304,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -8468,8 +8453,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -8618,8 +8602,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -8768,8 +8751,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -8918,8 +8900,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9072,8 +9053,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9137,8 +9117,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9202,8 +9181,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9313,8 +9291,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9411,8 +9388,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9478,8 +9454,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9580,8 +9555,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9647,8 +9621,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9756,8 +9729,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9832,8 +9804,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9888,8 +9859,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -9966,8 +9936,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10022,8 +9991,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10103,8 +10071,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10159,8 +10126,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10232,8 +10198,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10282,8 +10247,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10355,8 +10319,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10405,8 +10368,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10487,8 +10449,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10550,8 +10511,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10653,8 +10613,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10719,8 +10678,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -10826,8 +10784,7 @@
   cat conftest.err >&5
   echo "$as_me:$LINENO: \$? = $ac_status" >&5
   (exit $ac_status); } &&
-	 { ac_try='test -z "$ac_cxx_werror_flag"
-			 || test ! -s conftest.err'
+	 { ac_try='test -z "$ac_cxx_werror_flag"			 || test ! -s conftest.err'
   { (eval echo "$as_me:$LINENO: \"$ac_try\"") >&5
   (eval $ac_try) 2>&5
   ac_status=$?
@@ -11446,12 +11403,13 @@
 
 # For now, we hardcode that non-i386/X86_64 platforms are clipped and don't
 # need an external glibc for anything...
-if test "x$_cv_libc_kind" = "xGLIBC" -a \( "x$_cv_arch" = "xI386" -o "x$_cv_arch" = "xX86_64" \); then
+if test "x$_cv_libc_kind" = "xGLIBC" -a \( "x$_cv_arch" = "xI386" -o "x$_cv_arch" = "xX86_64" \) ; then
 
   _cv_libc_full_vers="$_cv_libc_major.$_cv_libc_minor.$_cv_libc_patch"
-  case "$_cv_libc_full_vers" in
-  "2.2.4" )
-    echo "$as_me:$LINENO: checking glibc" >&5
+  if  \! "x$_cv_opsys_vers" = "xLINUX_DEBIAN" ; then
+   case "$_cv_libc_full_vers" in
+   "2.2.4" )
+     echo "$as_me:$LINENO: checking glibc" >&5
 echo $ECHO_N "checking glibc... $ECHO_C" >&6
  _err_msg="The requested version of glibc (glibc-2.2.2) does not exist in $ac_cv_externals"
  if test ! -d "$ac_cv_externals/bundles/glibc"; then
@@ -11498,9 +11456,9 @@
 _ACEOF
 
 
-    ;;
-  "2.2.5" )
-    echo "$as_me:$LINENO: checking glibc" >&5
+     ;;
+   "2.2.5" )
+     echo "$as_me:$LINENO: checking glibc" >&5
 echo $ECHO_N "checking glibc... $ECHO_C" >&6
  _err_msg="The requested version of glibc (glibc-2.2.2) does not exist in $ac_cv_externals"
  if test ! -d "$ac_cv_externals/bundles/glibc"; then
@@ -11547,9 +11505,9 @@
 _ACEOF
 
 
-    ;;
-  "2.2.93" )
-    echo "$as_me:$LINENO: checking glibc" >&5
+     ;;
+   "2.2.93" )
+     echo "$as_me:$LINENO: checking glibc" >&5
 echo $ECHO_N "checking glibc... $ECHO_C" >&6
  _err_msg="The requested version of glibc (glibc-2.2.93) does not exist in $ac_cv_externals"
  if test ! -d "$ac_cv_externals/bundles/glibc"; then
@@ -11596,12 +11554,12 @@
 _ACEOF
 
 
-    ;;
-  "2.3.2" )
-    # the glibc 2.3.2 from redhat's source rpms are very different than the
-	# stock 2.3.2 you can download off of the web.
-	# This external is used both for x86 and x86_64
-    echo "$as_me:$LINENO: checking glibc" >&5
+     ;;
+   "2.3.2" )
+     # the glibc 2.3.2 from redhat's source rpms are very different than the
+	 # stock 2.3.2 you can download off of the web.
+	 # This external is used both for x86 and x86_64
+     echo "$as_me:$LINENO: checking glibc" >&5
 echo $ECHO_N "checking glibc... $ECHO_C" >&6
  _err_msg="The requested version of glibc (glibc-2.3.2.27.9.7) does not exist in $ac_cv_externals"
  if test ! -d "$ac_cv_externals/bundles/glibc"; then
@@ -11648,12 +11606,12 @@
 _ACEOF
 
 
-    ;;
-  "2.3.4" )
-  	# I'm using this here to avoid a full port of Condor to the centos 4 OS.
-	# XXX Also, one must use gcc 3.2.2 instead of as shipped gcc 3.4.4 to
-	# compile this package.
-    echo "$as_me:$LINENO: checking glibc" >&5
+     ;;
+   "2.3.4" )
+	 # I'm using this here to avoid a full port of Condor to the centos 4 OS.
+	 # XXX Also, one must use gcc 3.2.2 instead of as shipped gcc 3.4.4 to
+	 # compile this package.
+     echo "$as_me:$LINENO: checking glibc" >&5
 echo $ECHO_N "checking glibc... $ECHO_C" >&6
  _err_msg="The requested version of glibc (glibc-2.3.2.27.9.7) does not exist in $ac_cv_externals"
  if test ! -d "$ac_cv_externals/bundles/glibc"; then
@@ -11700,18 +11658,22 @@
 _ACEOF
 
 
-    ;;
-  * )
-    echo "$as_me:$LINENO: checking glibc" >&5
+     ;;
+   * )
+     echo "$as_me:$LINENO: checking glibc" >&5
 echo $ECHO_N "checking glibc... $ECHO_C" >&6
-    echo "$as_me:$LINENO: result: ERROR" >&5
+     echo "$as_me:$LINENO: result: ERROR" >&5
 echo "${ECHO_T}ERROR" >&6
-    { { echo "$as_me:$LINENO: error: Condor does NOT know what glibc external to use with glibc-$_cv_libc_full_vers" >&5
+     { { echo "$as_me:$LINENO: error: Condor does NOT know what glibc external to use with glibc-$_cv_libc_full_vers" >&5
 echo "$as_me: error: Condor does NOT know what glibc external to use with glibc-$_cv_libc_full_vers" >&2;}
    { (exit 1); exit 1; }; }
-  esac
-  want_ext_glibc=YES
+   esac
+   want_ext_glibc=YES
+
+  else
+   want_ext_glibc=NO
 
+  fi
 else
   want_ext_glibc=NO
 
@@ -13618,11 +13580,6 @@
 
 
 
-  if test x"$ac_file" != x-; then
-    { echo "$as_me:$LINENO: creating $ac_file" >&5
-echo "$as_me: creating $ac_file" >&6;}
-    rm -f "$ac_file"
-  fi
   # Let's still pretend it is `configure' which instantiates (i.e., don't
   # use $as_me), people would be surprised to read:
   #    /* config.h.  Generated by config.status.  */
@@ -13661,6 +13618,12 @@
 	 fi;;
       esac
     done` || { (exit 1); exit 1; }
+
+  if test x"$ac_file" != x-; then
+    { echo "$as_me:$LINENO: creating $ac_file" >&5
+echo "$as_me: creating $ac_file" >&6;}
+    rm -f "$ac_file"
+  fi
 _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF
   sed "$ac_vpsub

=== modified file 'src/configure.ac'
--- src/configure.ac	2006-10-17 15:28:36 +0000
+++ src/configure.ac	2006-10-19 07:52:56 +0000
@@ -256,9 +256,8 @@
     esac
   elif test -f "/etc/debian_version" ; then
     _deb_vers=`cat /etc/debian_version | sed 's/\./_/g'`;
-    _cv_linux_distro="DEBIAN_`echo _deb_vers`"
-    AC_MSG_WARN([Condor is not yet ported to Debian Linux distributions])
-    AC_MSG_WARN([You may have trouble building and/or packaging Condor]) 
+    _cv_opsys_vers="LINUX_DEBIAN"
+    _cv_linux_distro="DEBIAN"
   else
     AC_MSG_WARN([Unrecognised Linux distribution])
     AC_MSG_WARN([You may have trouble building and/or packaging Condor]) 
@@ -724,6 +723,12 @@
     CompilerMinor="3"
     CompilerPatch="4"
     ;;
+ "3.3.5" )
+    CompilerKind="GCC"
+    CompilerMajor="3"
+    CompilerMinor="3"
+    CompilerPatch="5"
+    ;;
  "3.4.2" )
     CompilerKind="GCC"
     CompilerMajor="3"
@@ -754,6 +759,18 @@
     CompilerMinor="0"
     CompilerPatch="1"
     ;;
+ "4.0.2" )
+    CompilerKind="GCC"
+    CompilerMajor="4"
+    CompilerMinor="0"
+    CompilerPatch="2"
+    ;;
+ "4.0.3" )
+    CompilerKind="GCC"
+    CompilerMajor="4"
+    CompilerMinor="0"
+    CompilerPatch="3"
+    ;;
  * )
    AC_MSG_RESULT([ERROR])
    AC_MSG_ERROR([Condor will not compile with gcc version $gcc_vers])
@@ -1704,37 +1721,41 @@
 
 # For now, we hardcode that non-i386/X86_64 platforms are clipped and don't
 # need an external glibc for anything...
-if test "x$_cv_libc_kind" = "xGLIBC" -a \( "x$_cv_arch" = "xI386" -o "x$_cv_arch" = "xX86_64" \); then
+if test "x$_cv_libc_kind" = "xGLIBC" -a \( "x$_cv_arch" = "xI386" -o "x$_cv_arch" = "xX86_64" \) ; then
 
   _cv_libc_full_vers="$_cv_libc_major.$_cv_libc_minor.$_cv_libc_patch"
-  case "$_cv_libc_full_vers" in
-  "2.2.4" )
-    CONDOR_EXTERNAL_VERSION([glibc],[2.2.2])
-    ;;
-  "2.2.5" )
-    CONDOR_EXTERNAL_VERSION([glibc],[2.2.2])
-    ;;
-  "2.2.93" )
-    CONDOR_EXTERNAL_VERSION([glibc],[2.2.93])
-    ;;
-  "2.3.2" )
-    # the glibc 2.3.2 from redhat's source rpms are very different than the
-	# stock 2.3.2 you can download off of the web.
-	# This external is used both for x86 and x86_64
-    CONDOR_EXTERNAL_VERSION([glibc],[2.3.2.27.9.7])
-    ;;
-  "2.3.4" )
-  	# I'm using this here to avoid a full port of Condor to the centos 4 OS.
-	# XXX Also, one must use gcc 3.2.2 instead of as shipped gcc 3.4.4 to 
-	# compile this package.
-    CONDOR_EXTERNAL_VERSION([glibc],[2.3.2.27.9.7])
-    ;;
-  * )  
-    AC_MSG_CHECKING(glibc)
-    AC_MSG_RESULT([ERROR])
-    AC_MSG_ERROR([Condor does NOT know what glibc external to use with glibc-$_cv_libc_full_vers])
-  esac
-  AC_SUBST(want_ext_glibc,YES)
+  if  \! "x$_cv_opsys_vers" = "xLINUX_DEBIAN" ; then
+   case "$_cv_libc_full_vers" in
+   "2.2.4" )
+     CONDOR_EXTERNAL_VERSION([glibc],[2.2.2])
+     ;;
+   "2.2.5" )
+     CONDOR_EXTERNAL_VERSION([glibc],[2.2.2])
+     ;;
+   "2.2.93" )
+     CONDOR_EXTERNAL_VERSION([glibc],[2.2.93])
+     ;;
+   "2.3.2" )
+     # the glibc 2.3.2 from redhat's source rpms are very different than the
+	 # stock 2.3.2 you can download off of the web.
+	 # This external is used both for x86 and x86_64
+     CONDOR_EXTERNAL_VERSION([glibc],[2.3.2.27.9.7])
+     ;;
+   "2.3.4" )
+	 # I'm using this here to avoid a full port of Condor to the centos 4 OS.
+	 # XXX Also, one must use gcc 3.2.2 instead of as shipped gcc 3.4.4 to 
+	 # compile this package.
+     CONDOR_EXTERNAL_VERSION([glibc],[2.3.2.27.9.7])
+     ;;
+   * )  
+     AC_MSG_CHECKING(glibc)
+     AC_MSG_RESULT([ERROR])
+     AC_MSG_ERROR([Condor does NOT know what glibc external to use with glibc-$_cv_libc_full_vers])
+   esac
+   AC_SUBST(want_ext_glibc,YES)
+  else
+   AC_SUBST(want_ext_glibc,NO)
+  fi
 else
   AC_SUBST(want_ext_glibc,NO)
   AC_SUBST(ext_glibc_version,UNUSED)

=== modified file 'src/stork/Imakefile'
--- src/stork/Imakefile	2006-10-17 15:28:36 +0000
+++ src/stork/Imakefile	2006-10-19 07:32:37 +0000
@@ -6,7 +6,7 @@
 /* Specify Stork build configuration here. */
 #define WANT_STORK_API			YES
 #define WANT_STORK_GLOBUS		YES
-#define WANT_STORK_SRB			YES
+#define WANT_STORK_SRB			NO
 #define WANT_STORK_UNITREE		YES
 #define WANT_STORK_SRM_CASTOR	YES
 #define WANT_STORK_SRM_DCACHE	YES

=== modified file 'src/stork/dap_client_interface.C'
--- src/stork/dap_client_interface.C	2006-10-17 15:28:36 +0000
+++ src/stork/dap_client_interface.C	2006-10-18 23:02:29 +0000
@@ -242,7 +242,7 @@
 	}
 	free (_request);
 
-	sock->code ((int)cred_size);
+	sock->code ((int*)&cred_size);
 	if (cred_size) {
 		char * _cred = strdup (cred);  
 		sock->code_bytes (_cred, cred_size);